Bug 1273741 - [Tier]: Migration of hardlinks failed on tier volume
[Tier]: Migration of hardlinks failed on tier volume
Status: CLOSED WONTFIX
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: tier (Show other bugs)
3.1
x86_64 Linux
high Severity high
: ---
: ---
Assigned To: hari gowtham
nchilaka
: ZStream
Depends On:
Blocks: 1268895 1276742
  Show dependency treegraph
 
Reported: 2015-10-21 03:27 EDT by Rahul Hinduja
Modified: 2018-02-06 12:34 EST (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Known Issue
Doc Text:
Files with hard links are not promoted or demoted on tiered volumes.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2018-02-06 12:34:47 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Rahul Hinduja 2015-10-21 03:27:05 EDT
Description of problem:
=======================

While creating hardlinks of files noticed the migration failure from cold to hot with message "file has hardlinks". Creating bug as tracker for hardlinks:

Tier log snippet:
=================

[2015-10-20 19:06:01.703887] I [MSGID: 109038] [tier.c:476:tier_migrate_using_query_file] 0-tiervolume-tier-dht: Tier 1 src_subvol tiervolume-cold-dht file 562688c6%%H344VEA3BD
[2015-10-20 19:06:01.711186] I [dht-rebalance.c:1103:dht_migrate_file] 0-tiervolume-tier-dht: /thread4/level00/hardlink_to_files/562688c6%%H344VEA3BD: attempting to move from tiervolume-cold-dht to tiervolume-hot-dht
[2015-10-20 19:06:01.714739] W [MSGID: 109023] [dht-rebalance.c:433:__is_file_migratable] 0-tiervolume-tier-dht: Migrate file failed:/thread4/level00/hardlink_to_files/562688c6%%H344VEA3BD: file has hardlinks
[2015-10-20 19:06:01.715836] E [MSGID: 109037] [tier.c:492:tier_migrate_using_query_file] 0-tiervolume-tier-dht: ERROR -22 in current migration 562688c6%%H344VEA3BD /thread4/level00/hardlink_to_files/562688c6%%H344VEA3BD

[2015-10-20 19:06:01.723330] I [MSGID: 109038] [tier.c:476:tier_migrate_using_query_file] 0-tiervolume-tier-dht: Tier 1 src_subvol tiervolume-cold-dht file 56268047%%QI7LKOAXES
[2015-10-20 19:06:01.726445] I [dht-rebalance.c:1103:dht_migrate_file] 0-tiervolume-tier-dht: /thread4/level00/56268047%%QI7LKOAXES: attempting to move from tiervolume-cold-dht to tiervolume-hot-dht
[2015-10-20 19:06:01.728671] W [MSGID: 109023] [dht-rebalance.c:433:__is_file_migratable] 0-tiervolume-tier-dht: Migrate file failed:/thread4/level00/56268047%%QI7LKOAXES: file has hardlinks
[2015-10-20 19:06:01.729906] E [MSGID: 109037] [tier.c:492:tier_migrate_using_query_file] 0-tiervolume-tier-dht: ERROR -22 in current migration 56268047%%QI7LKOAXES /thread4/level00/56268047%%QI7LKOAXES

[2015-10-20 19:06:01.736238] I [MSGID: 109038] [tier.c:476:tier_migrate_using_query_file] 0-tiervolume-tier-dht: Tier 1 src_subvol tiervolume-cold-dht file 56268048%%9DTTKHAP29
[2015-10-20 19:06:01.740812] I [dht-rebalance.c:1103:dht_migrate_file] 0-tiervolume-tier-dht: /thread2/level00/56268048%%9DTTKHAP29: attempting to move from tiervolume-cold-dht to tiervolume-hot-dht
[2015-10-20 19:06:01.743015] W [MSGID: 109023] [dht-rebalance.c:433:__is_file_migratable] 0-tiervolume-tier-dht: Migrate file failed:/thread2/level00/56268048%%9DTTKHAP29: file has hardlinks
[2015-10-20 19:06:01.744684] E [MSGID: 109037] [tier.c:492:tier_migrate_using_query_file] 0-tiervolume-tier-dht: ERROR -22 in current migration 56268048%%9DTTKHAP29 /thread2/level00/56268048%%9DTTKHAP29

[2015-10-20 19:06:01.750841] I [MSGID: 109038] [tier.c:476:tier_migrate_using_query_file] 0-tiervolume-tier-dht: Tier 1 src_subvol tiervolume-cold-dht file 562688c6%%FY4V40PT04
[2015-10-20 19:06:01.755828] I [dht-rebalance.c:1103:dht_migrate_file] 0-tiervolume-tier-dht: /thread2/level00/hardlink_to_files/562688c6%%FY4V40PT04: attempting to move from tiervolume-cold-dht to tiervolume-hot-dht
[2015-10-20 19:06:01.758222] W [MSGID: 109023] [dht-rebalance.c:433:__is_file_migratable] 0-tiervolume-tier-dht: Migrate file failed:/thread2/level00/hardlink_to_files/562688c6%%FY4V40PT04: file has hardlinks
[2015-10-20 19:06:01.760033] E [MSGID: 109037] [tier.c:492:tier_migrate_using_query_file] 0-tiervolume-tier-dht: ERROR -22 in current migration 562688c6%%FY4V40PT04 /thread2/level00/hardlink_to_files/562688c6%%FY4V40PT04

Version-Release number of selected component (if applicable):
=============================================================

glusterfs-3.7.5-0.3.el7rhgs.x86_64


How reproducible:
=================

Always


Steps to Reproduce:
===================
1. Create files from client using:
crefi --multi -n 10 -b 10 -d 10 --max=1024k --min=5k --random -T 5 -t text -I 5 --fop=create /mnt/fuse/
2. Once data creation is completed, create hardlinks of files using:
crefi --multi -n 10 -b 10 -d 10 --max=1024k --min=5k --random -T 5 -t text -I 5 --fop=hardlink /mnt/fuse/

Actual results:
===============

Hardlinks of files are created successfully from client, but the migration fails. 

Expected results:
=================

Migration should succeed for link files
Comment 3 nchilaka 2015-10-27 02:38:30 EDT
we need to document the limitation.
Removing blocker tag
Comment 20 Shyamsundar 2018-02-06 12:34:47 EST
Thank you for your bug report.

This bug has documentation updated on the problem reported.

Further we are no longer releasing any bug fixes or, other updates for Tier. This bug will be set to CLOSED WONTFIX to reflect this.

Note You need to log in before you can comment on or make changes to this bug.